//go:build !arm64
// +build !arm64

package fp

// MulBy3 x *= 3 (mod q)
func MulBy3(x *Element) {
	_x := *x
	x.Double(x).Add(x, &_x)
}

// MulBy5 x *= 5 (mod q)
func MulBy5(x *Element) {
	_x := *x
	x.Double(x).Double(x).Add(x, &_x)
}

// MulBy13 x *= 13 (mod q)
func MulBy13(x *Element) {
	var y = Element{
		1176283927673829444,
		14130787773971430395,
		11354866436980285261,
		15740727779991009548,
		14951814113394531041,
		33013799364667434,
	}
	x.Mul(x, &y)
}

// Mul x*y (mod q)
func (z *Element) Mul(x, y *Element) *Element {
	return z._mulGeneric(x, y)
}

// Square x^2 (mod q)
func (z *Element) Square(x *Element) *Element {
	return z._mulGeneric(x, x)
}

// Butterfly sets
//
//	a = a + b (mod q)
//	b = a - b (mod q)
func Butterfly(a, b *Element) {
	_butterflyGeneric(a, b)
}

func fromMont(z *Element) {
	_fromMontGeneric(z)
}

func reduce(z *Element) {
	_reduceGeneric(z)
}
