//go:build !arm64
// +build !arm64

package fr

// MulBy3 x *= 3 (mod q)
func MulBy3(x *Element) {
	_x := *x
	x.Double(x).Add(x, &_x)
}

// MulBy5 x *= 5 (mod q)
func MulBy5(x *Element) {
	_x := *x
	x.Double(x).Double(x).Add(x, &_x)
}

// MulBy13 x *= 13 (mod q)
func MulBy13(x *Element) {
	var y = Element{
		18434640649710993230,
		12067750152132099910,
		14024878721438555919,
		347766975729306096,
	}
	x.Mul(x, &y)
}

// Mul x*y (mod q)
func (z *Element) Mul(x, y *Element) *Element {
	return z._mulGeneric(x, y)
}

// Square x^2 (mod q)
func (z *Element) Square(x *Element) *Element {
	return z._mulGeneric(x, x)
}

func fromMont(z *Element) {
	_fromMontGeneric(z)
}

func reduce(z *Element) {
	_reduceGeneric(z)
}
